// file      : xsd/cxx/parser/types.ixx
// author    : Boris Kolpackov <boris@codesynthesis.com>
// copyright : Copyright (c) 2005 Code Synthesis Tools CC
// license   : GNU GPL v2 + exceptions; see accompanying LICENSE file

#if defined(XSD_USE_CHAR) || !defined(XSD_USE_WCHAR)

#ifndef XSD_CXX_PARSER_TYPES_IXX_CHAR
#define XSD_CXX_PARSER_TYPES_IXX_CHAR

namespace xsd
{
  namespace cxx
  {
    namespace parser
    {
      template<>
      inline
      void boolean<char>::
      characters (std::basic_string<char> const& s)
      {
        v_ = (s == "true") || (s == "1");
      }
    }
  }
}

#endif // XSD_CXX_PARSER_TYPES_IXX_CHAR
#endif // XSD_USE_CHAR


#if defined(XSD_USE_WCHAR) || !defined(XSD_USE_CHAR)

#ifndef XSD_CXX_PARSER_TYPES_IXX_WCHAR
#define XSD_CXX_PARSER_TYPES_IXX_WCHAR

namespace xsd
{
  namespace cxx
  {
    namespace parser
    {
      template<>
      inline
      void boolean<wchar_t>::
      characters (std::basic_string<wchar_t> const& s)
      {
        v_ = (s == L"true") || (s == L"1");
      }
    }
  }
}

#endif // XSD_CXX_PARSER_TYPES_IXX_WCHAR
#endif // XSD_USE_WCHAR
