// file      : xsd/cxx/tree/elements.ixx
// author    : Boris Kolpackov <boris@codesynthesis.com>
// copyright : Copyright (c) 2005 Code Synthesis Tools CC
// license   : GNU GPL v2 + exceptions; see accompanying LICENSE file

#if defined(XSD_USE_CHAR) || !defined(XSD_USE_WCHAR)

#ifndef XSD_CXX_TREE_ELEMENTS_IXX_CHAR
#define XSD_CXX_TREE_ELEMENTS_IXX_CHAR

namespace xsd
{
  namespace cxx
  {
    namespace tree
    {
      // Specialization for 'bool'.
      //

      template<>
      template<>
      inline
      fundamental_base<bool>::
      fundamental_base (xml::dom::element<char> const& e)
      {
        x_ = (e.value () == "true") || (e.value () == "1");
      }

      template<>
      template<>
      inline
      fundamental_base<bool>::
      fundamental_base (xml::dom::attribute<char> const& a)
      {
        x_ = (a.value () == "true") || (a.value () == "1");
      }

      template<>
      template<>
      inline
      fundamental_base<bool>::
      fundamental_base (std::basic_string<char> const& s,
                        xml::dom::element<char> const&)
      {
        x_ = (s == "true") || (s == "1");
      }
    }
  }
}

#endif // XSD_CXX_TREE_ELEMENTS_IXX_CHAR
#endif // XSD_USE_CHAR


#if defined(XSD_USE_WCHAR) || !defined(XSD_USE_CHAR)

#ifndef XSD_CXX_TREE_ELEMENTS_IXX_WCHAR
#define XSD_CXX_TREE_ELEMENTS_IXX_WCHAR

namespace xsd
{
  namespace cxx
  {
    namespace tree
    {
      // Specialization for 'bool'.
      //

      template<>
      template<>
      inline
      fundamental_base<bool>::
      fundamental_base (xml::dom::element<wchar_t> const& e)
      {
        x_ = (e.value () == L"true") || (e.value () == L"1");
      }

      template<>
      template<>
      inline
      fundamental_base<bool>::
      fundamental_base (xml::dom::attribute<wchar_t> const& a)
      {
        x_ = (a.value () == L"true") || (a.value () == L"1");
      }

      template<>
      template<>
      inline
      fundamental_base<bool>::
      fundamental_base (std::basic_string<wchar_t> const& s,
                        xml::dom::element<wchar_t> const&)
      {
        x_ = (s == L"true") || (s == L"1");
      }
    }
  }
}

#endif // XSD_CXX_TREE_ELEMENTS_IXX_WCHAR
#endif // XSD_USE_WCHAR
